#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <mysql/mysql.h>
#define INSERT "insert into data values(?,?,?,?,?,?)"
#define DROP "drop table data"
#define CREATE "create table data (stamp int not null,"\
               " module smallint not null, type smallint not null,"\
	       " scale1 double, scale2 double, data blob,"\
	       " primary key(stamp, module, type)) avg_row_length=100000 max_rows=1000000000"

int main()
{
int i, num_fields,param_count;
MYSQL_RES *result;
MYSQL_ROW row;
MYSQL_STMT* stmt;
MYSQL_BIND bind[6];

int t=time(NULL);
short int module = 1;
short int type = 2;
double d1=2.34;
double d2=4.56;
char* blob;
unsigned long blob_length=10000;
blob=malloc(blob_length);

MYSQL* mysql=mysql_init(NULL);
if(!mysql_real_connect(mysql,"localhost","","","solar",0,NULL,0))
  printf("Connect failed: %s\n",mysql_error(mysql));

if(mysql_query(mysql,DROP))
{
  fprintf(stderr, " mysql_query() failed\n");
  fprintf(stderr, " %s\n", mysql_error(mysql));
};  

if(mysql_query(mysql,CREATE))
{
  fprintf(stderr, " mysql_query() failed\n");
  fprintf(stderr, " %s\n", mysql_error(mysql));
  exit(0);
};  


stmt=mysql_prepare(mysql, INSERT, sizeof(INSERT));
if(!stmt)
{
  fprintf(stderr, " mysql_prepare(), INSERT failed\n");
  fprintf(stderr, " %s\n",mysql_error(mysql));
  exit(0);
};
fprintf(stdout, " prepare, INSERT successful\n");

param_count=mysql_param_count(stmt);
fprintf(stdout, "total parameters in INSERT: %d\n",param_count);
//assert(param_count==sizeof(bind)/sizeof(bind[0]));
bind[0].buffer_type=MYSQL_TYPE_LONG;
bind[0].buffer=(char*)&t;
bind[0].is_null=0;
bind[0].length=0;

bind[1].buffer_type=MYSQL_TYPE_SHORT;
bind[1].buffer=(char*)&module;
bind[1].is_null=0;
bind[1].length=0;

bind[2].buffer_type=MYSQL_TYPE_SHORT;
bind[2].buffer=(char*)&type;
bind[2].is_null=0;
bind[2].length=0;

bind[3].buffer_type=MYSQL_TYPE_DOUBLE;
bind[3].buffer=(char*)&d1;
bind[3].is_null=0;
bind[3].length=0;

bind[4].buffer_type=MYSQL_TYPE_DOUBLE;
bind[4].buffer=(char*)&d2;
bind[4].is_null=0;
bind[4].length=0;

bind[5].buffer_type=MYSQL_TYPE_BLOB;
bind[5].buffer=(char*)blob;
bind[5].is_null=0;
bind[5].length=&blob_length;

if(mysql_bind_param(stmt,bind))
{
  fprintf(stderr, " mysql_bind_param() failed\n");
  fprintf(stderr, " %s\n", mysql_stmt_error(stmt));
  exit(0);
};  

for(i=0;i<10000;i++)
{
printf("Inserting: %d\n",i);
t++;
if(mysql_execute(stmt))
{
  fprintf(stderr, " mysql_execute() failed\n");
  fprintf(stderr, " %s\n", mysql_stmt_error(stmt));
  exit(0);
};
};  

if(mysql_stmt_close(stmt))
{
  fprintf(stderr, " mysql_execute() failed\n");
  fprintf(stderr, " %s\n", mysql_stmt_close(stmt));
  exit(0);
};  
 
free(blob);
mysql_close(mysql);
};