#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <mysql/mysql.h>
#define INSERT "insert into data values(?,?,?,?,?,?)"
#define DROP "drop table data"
#define CREATE "create table data (stamp int not null,"\
               " module smallint not null, type smallint not null,"\
	       " scale1 double, scale2 double, data blob,"\
	       " primary key(stamp, module, type)) avg_row_length=100000 max_rows=1000000000"
#define SELECT "select * from data"

int main()
{
int i, num_fields,param_count;
MYSQL_RES *result;
MYSQL_ROW row;
MYSQL_STMT* stmt;
MYSQL_BIND bind[6];

int t=10;
short int module = 1;
short int type = 2;
double d1=2.34;
double d2=4.56;
char* blob;
unsigned long blob_length=200000;
unsigned long real_len;
my_bool is_null[6];
blob=malloc(blob_length);

MYSQL* mysql=mysql_init(NULL);
if(!mysql_real_connect(mysql,"localhost","","","solar",0,NULL,0))
  printf("Connect failed: %s\n",mysql_error(mysql));


stmt=mysql_prepare(mysql, SELECT, sizeof(INSERT));
if(!stmt)
{
  fprintf(stderr, " mysql_prepare(), SELECT failed\n");
  fprintf(stderr, " %s\n",mysql_error(mysql));
  exit(0);
};
fprintf(stdout, " prepare, SELECT successful\n");

param_count=mysql_param_count(stmt);
fprintf(stdout, "total parameters in SELECT: %d\n",param_count);
//assert(param_count==sizeof(bind)/sizeof(bind[0]));
bind[0].buffer_type=MYSQL_TYPE_LONG;
bind[0].buffer=(char*)&t;
bind[0].is_null=is_null;
bind[0].length=0;

bind[1].buffer_type=MYSQL_TYPE_SHORT;
bind[1].buffer=(char*)&module;
bind[1].is_null=is_null+1;
bind[1].length=0;

bind[2].buffer_type=MYSQL_TYPE_SHORT;
bind[2].buffer=(char*)&type;
bind[2].is_null=is_null+2;
bind[2].length=0;

bind[3].buffer_type=MYSQL_TYPE_DOUBLE;
bind[3].buffer=(char*)&d1;
bind[3].is_null=is_null+3;
bind[3].length=0;

bind[4].buffer_type=MYSQL_TYPE_DOUBLE;
bind[4].buffer=(char*)&d2;
bind[4].is_null=is_null+4;
bind[4].length=0;

bind[5].buffer_type=MYSQL_TYPE_BLOB;
bind[5].buffer=(char*)blob;
bind[5].is_null=is_null+5;
bind[5].buffer_length=blob_length;
bind[5].length=&real_len;

if(mysql_bind_result(stmt,bind))
{
  fprintf(stderr, " mysql_bind_result() failed\n");
  fprintf(stderr, " %s\n", mysql_stmt_error(stmt));
  exit(0);
};  

if(mysql_execute(stmt))
{
  fprintf(stderr, " mysql_execute() failed\n");
  fprintf(stderr, " %s\n", mysql_stmt_error(stmt));
  exit(0);
};

fprintf(stdout, " Fetching results ... \n");

while(!mysql_fetch(stmt))
{
  printf("%d\n",t);
};

if(mysql_stmt_close(stmt))
{
  fprintf(stderr, " mysql_execute() failed\n");
  fprintf(stderr, " %s\n", mysql_stmt_close(stmt));
  exit(0);
};  
 
free(blob);
mysql_close(mysql);
};